/*1-26-2020 last upload to block press
 
 
 Open Source Ecology CEB Press v19.01_Belize with Arduino Mega 2560 as controller of choice.
 CC-BY-SA, GPLv3, and OSE License for Distributive Economics


MACHINE DIRECTIONS ARE SCREWED UP! IGNORE LEFT/RIGHT. I WILL FIX IT LATER - AIDAN 11/10/2019


 Switches relays to control two hydraulic solenoids

 Orientation of machine is such that drawer cylinder retracts to the right.
 See sequence at http://bit.ly/2Hnuk6F
 Main Cylinder   : 5   x 8  x 2.5
 Drawer Cylinder : 2.5 x 14 x 1.25
 Volume of drawer extension:  68.6875 cu in
 Volume of main cyl retract: 117.0796 cu in
 Ratio of Main Cylinder Retract Volume to Drawer Cylinder Extension Volume: 1.72


 Uses HiLetgo Relay Shield 5V 4 Channel for Arduino:

 https://www.amazon.com/HiLetgo-Relay-Shield-Channel-Arduino/dp/B07F7Y55Z7/ref=sr_1_2?ie=UTF8&qid=1547696929&sr=8-2&keywords=hiletgo+relay+shield

 Note pins must be trimmed flat under Relay 1 connector and must be insulated to prevent shorts.

 Relay 1 is controlled by digital pin 7
 Relay 2 is controlled by digital pin 6
 Relay 3 is controlled by digital pin 5
 Relay 4 is controlled by digital pin 4

 A high written to a pin turns the relay ON
 A low written to a pin turns the relay OFF

 Belize Edition uses manual control buttons and some inductive proximity sensors.
 Uses a proto-shield such as link below to land 12v i/o and drop to 5v with voltage divider.
 https://www.amazon.com/WINGONEER-Prototype-Arduino-Shield-Board/dp/B01FTWJR9I/ref=sr_1_8?keywords=arduino+2560+shield&qid=1568585015&s=electronics&sr=1-8
 Uses Normally Open (NO) Buttons to switch GND to digital inputs
 [link]



 Contributions by:
 Abe Anderson
 http://opensourceecology.org/wiki/AbeAnd_Log
 Marcin Jakubowski
 http://opensourceecology.org/wiki/Marcin_Log
 Aidan Williamson
 http://wiki.opensourceecology.org/wiki/Aidan_Log
 Scott Mader
 Progresso Village, Belize
 Gabriel Kind
 https://wiki.opensourceecology.org/wiki/Gabriel_Kind_log


 Unfamiliar with code structures? See https://www.arduino.cc/en/Reference/HomePage
 */

//Defines are preprocessor directives, which do a text find and replace prior to compilation. 

#define PRESSURE_SENSOR_DEBOUNCE 5     //milliseconds to delay for pressure sensor debounce
#define TURNOFF_DELAY 50                //Addresses 40 ms turnoff time of solenoid. Loses 1 second every minute.
#define PRESS_DELAY 1250                      // Increased to try to improve block compression


            

 //Global variables
unsigned long previousMillis = 0;       //time measurement for expansion
unsigned long drawerBeginTime = 0;      //time drawer cyl came on
unsigned long drawerEndTime = 0;        //time drawer cyl turned off
unsigned long drawerMoveTime =0;        //end - begin
unsigned long pressureReliefTime=50;     //depressurize cylinder after high pressure
unsigned long mainBeginTime = 0;        //time press cyl came on
unsigned long mainEndTime = 0;          //time press cyl should turn off
unsigned long lastStateChange = 0;
float cylVolRatio = 1.72;                //see calculation above


// Set Pin Definitions
//Solenoids
int SOLENOID_UP=7;
int SOLENOID_DOWN=6;
int SOLENOID_LEFT=4;                     
int SOLENOID_RIGHT=5;

//Brick Thickness Selector Switch
//Belize Edition moved these to GND side of double io header
int SELECTOR_FULL=45;             //Red wire
int SELECTOR_THREEQUARTER=47;     //Black Wire
int SELECTOR_HALF=49;             //White Wire
int SELECTOR_QUARTER=51;          //Grey wire

//Manual Control Buttons
int btnU=24;          //up button input
int btnD=26;          //down
int btnL=32;          //left
int btnR=30;          //right
int btnM=34;           //mid-point button

//Auto-Manual Switch
int switchAUTO=0;

//Sensors
int PRESSURE_SENSOR=53;    
int drawerMidSens=13; //mid point sensor on drawer
int drawerLeftSens=12; //fully extended
int drawerRightSens=11; //fully retracted

//Debounces
int dePressure=100;
int deButton=3;

//GLOBAL FLAGS
boolean automode=false;
boolean stateIsSetup=false;
boolean pressureIsPrinted=false;
boolean drawerGoMidFlag=false;
boolean drawerGoRevMid=false;
boolean dropTimePrinted=false;
boolean automodePrinted=false;


//Pressure Sensor debounced read
boolean pressureIsHigh(){
  if(digitalRead(PRESSURE_SENSOR)==LOW){
    delay(dePressure);
    if(digitalRead(PRESSURE_SENSOR)==LOW){
    //Serial.println("Pressure High!");
      return true;
    }
  }
  return false;
}


boolean midPointHigh(){
  if(digitalRead(drawerMidSens==HIGH)){
    return true;
  }
  return false;
}

//Selector Switch Read
int selectorCheck(){
  if(digitalRead(SELECTOR_QUARTER)==LOW){
    delay(deButton);
    if(digitalRead(SELECTOR_QUARTER)==LOW){
      return 1;
   }
  }
  else if(digitalRead(SELECTOR_HALF)==LOW){
    delay(deButton);
    if(digitalRead(SELECTOR_HALF)==LOW){
      return 2;
    }
  }
  else if(digitalRead(SELECTOR_THREEQUARTER)==LOW){
    delay(deButton);
    if(digitalRead(SELECTOR_THREEQUARTER)==LOW){
      return 3;
    }
  }
  else if(digitalRead(SELECTOR_FULL)==LOW){
    delay(deButton);
    if(digitalRead(SELECTOR_FULL)==LOW){
      return 4;
    }
  }
  else if(digitalRead(SELECTOR_QUARTER)==HIGH && digitalRead(SELECTOR_HALF)==HIGH && digitalRead(SELECTOR_THREEQUARTER)==HIGH && digitalRead(SELECTOR_FULL==HIGH)){
    return 0;
  }
}

  
void runButtons(){        //this is the function for controlling the machine manually via buttons
 if(automode) {return;}        //if we ended up here somehow when the on switch is on auto, get out

 if(digitalRead(btnU)==LOW){    //if we read up button on, wait 3ms for debounce
  delay(deButton);
  if(digitalRead(btnU)==LOW){    //if we read it low still set solenoid on
   // Serial.println("BUTTON UP");
    digitalWrite(SOLENOID_UP,HIGH);
  }
 }else{
    //delay(deButton);
  if(digitalRead(btnU)==HIGH){    //if after debounce it is high set it off
    digitalWrite(SOLENOID_UP,LOW);        
  }
 }

 if(digitalRead(btnD)==LOW){    //if down button is presssed, debounce dat ish
  delay(deButton);
  if(digitalRead(btnD)==LOW){    //still low? ok, drive dat puppy
    digitalWrite(SOLENOID_DOWN,HIGH);
  }
 }else{                //otherwise turn off the solenoid and check the next button
    //delay(deButton);
    if(digitalRead(btnD)==HIGH){
      digitalWrite(SOLENOID_DOWN,LOW);
    }
 }
 
 if(digitalRead(btnL)==LOW){    //if left button is low, debounce it
  delay(deButton);
  if(digitalRead(btnL)==LOW){    //still low? turn on solenoid
     digitalWrite(SOLENOID_LEFT,HIGH);
  }
 }else{                //otherwise turn off solenoid and move on to right button
    //delay(deButton);
    if(digitalRead(btnL)==HIGH){
      digitalWrite(SOLENOID_LEFT,LOW);
    }
 }
  
if(digitalRead(btnR)==LOW){
  delay(deButton);
  if(digitalRead(btnR)==LOW)
     digitalWrite(SOLENOID_RIGHT,HIGH);
  }
 else{
   //delay(deButton);
   if(digitalRead(btnR)==HIGH){
     digitalWrite(SOLENOID_RIGHT,LOW);
   }
 }
}


void drawerGoMid(){                       //Mid position function for drawer
 if(automode){return;}
 if(digitalRead(btnM)==LOW){              //if button is pressed
  if(!drawerGoMidFlag){                   //if we haven't set the flag
    Serial.println("Debouncing Mid Button");
    delay(deButton);                      //debounce
    if (digitalRead(btnM)==LOW){          //if button still pressed
      Serial.println("Turning on Output and drawerGoMidFlag");
      digitalWrite(SOLENOID_LEFT, HIGH);  //assume we start from extended position
      drawerGoMidFlag=true;               //turn flag on 
      drawerGoRevMid=false;
    }
  }
 }
 
 if(drawerGoMidFlag){                                             //if our flag to go to mid point has come on
  if(!drawerGoRevMid){                                            //and the flag to go reverse to mid is off
    digitalWrite(SOLENOID_LEFT, HIGH);                            //retract cylinder
    Serial.println("Cylinder Retracting");
    if(digitalRead(drawerMidSens)==HIGH){                         //if we hit mid position
      digitalWrite(SOLENOID_LEFT, LOW);                          //turn off cylinder. THIS MUST COME BEFORE THE SERIAL PRINT OTHERWISE THE DELAY AFFECTS THE STOP POINT
      Serial.println("Drawer at Mid Position");
                                 
      drawerGoMidFlag=false;                                      //turn off flag
      return;                                                     //exit subroutine
    }
    if(pressureIsHigh() || digitalRead(drawerRightSens)==HIGH){      //if we have missed the midpoint and bottomed out
      if(!drawerGoRevMid){                                                //if state is not setup
        digitalWrite(SOLENOID_LEFT, LOW);                                //turn off retract
        Serial.println("Going Other Direction");                          //we're going the other way
        digitalWrite(SOLENOID_RIGHT, HIGH);                                //turn on extend
        drawerGoRevMid=true;                                              //turn on reverse flag
      }
    }
  }else if(drawerGoRevMid){                                              //if reverse flag is on
    digitalWrite(SOLENOID_RIGHT,HIGH);                                  //keep extending cylinder       
    if(digitalRead(drawerMidSens)==HIGH){                               //if we hit mid position while in reverse
      Serial.println("Delaying for sensor offset");                     
      delay(125);                                                       //sensor offset delay. This should be changed to be a factor of time from beginning of extension to midpoint detection
      digitalWrite(SOLENOID_RIGHT,LOW);                                  //turn of cylinder and flags
      drawerGoMidFlag=false;
      drawerGoRevMid=false;
    }
    else if(pressureIsHigh()|| digitalRead(drawerLeftSens)==HIGH){  //if we missed the mid-position and bottomed out again
      digitalWrite(SOLENOID_RIGHT,LOW);                                //turn off cylinder
      Serial.println("Failed to Find Mid Stroke");                    
      drawerGoRevMid=false;                                           //turn off flags
      drawerGoMidFlag=false;
    }
   
   }
  
  }         //end of if(drawerGoMidFlag){}
  
 }          //end of void drawerGoMid()






/*
This is a state machine like the one used in WKJCEB.ino 2014.
There are some subroutines that help the state machine function. These appear before the runAuto() routine.
The states are:
1) PUSHBLOCK     - Pushes the raised block out of the machine with the drawer
2) LOADSOIL      - Lowers the press foot to a specified height 
3) CLOSECHAMBER  - Obstructs the press chamber with the drawer at mid-stroke
4) PRESSBLOCK    - Raises the press cylinder until high pressure, holds at high pressure for 2.5s, and then drops the press plate slightly
5) OPENCHAMBER   - Moves the drawer to allow the block to be raised
6) RAISEBLOCK    - Moves the press cylinder up to eject the block

*/

const short PUSHBLOCK    =0;
const short LOADSOIL     =1;
const short CLOSECHAMBER =2;
const short PRESSBLOCK   =3;
const short OPENCHAMBER  =4;
const short RAISEBLOCK   =5;

short autoState = PUSHBLOCK;              //start at step 0

unsigned long dropTime(){                                 //SET DROP TIMES HERE!
  if(!automode){return;};
  if(selectorCheck()==1){
    return (unsigned long)(drawerMoveTime*cylVolRatio*38/128);  //quarter block
  }
  else if(selectorCheck()==2){
    return (unsigned long)(drawerMoveTime*cylVolRatio*65/128);   //Two Inch Block
  }
  else if(selectorCheck()==3){
    return(unsigned long)(drawerMoveTime*cylVolRatio*92/128);   //three quarter block
  }
  else if (selectorCheck()==4){
    return(unsigned long)(drawerMoveTime*cylVolRatio*114/128); // Four Inch Block
  }
  else if(selectorCheck()==0){                             // Maximum size block (around 4.75")
    return;
  }
}

void setAuto(){                                    //Set state based on switch position. This is a void instead of a bool because we are calling another function from it.
  
    if(digitalRead(switchAUTO)==LOW){
    delay(deButton); //debounce
       if(digitalRead(switchAUTO)==LOW && !automode){     //1-26-2020 added !automode condition. Fixed automode issue.
         automode=true;
         if(automodePrinted==false){
          Serial.println("Auto Mode Enabled");
          automodePrinted=true;
         }
        }
    }
  
  
    else if(digitalRead(switchAUTO)==HIGH){         //If the autoswitch is not on, make sure that automode flag is off
      delay(deButton);
      if(automode && digitalRead(switchAUTO)==HIGH){
  
        //Turn off automode and handle variables cleanly
       automode=false;
       dropTimePrinted=false;
       Serial.println("Auto Mode Disabled");
       automodePrinted=false;
       terminateAutoExec();
      }
    }
}
void changeAutoState(int nextState){        //call this function with a variable that it will refer to as nextState
  autoState = nextState;                    //set our autoState to be the called state
  Serial.print("Autostate Changed To:");
  Serial.println(autoState, DEC);
  stateIsSetup = false;                     //This is used by every state in the execAuto machine to indicate that the next state must run its setup procedure                                           
  lastStateChange = millis();               //This marks the time at which states were changed
}

void turnAllSolenoidsOff(){
  digitalWrite(SOLENOID_UP, LOW);
  digitalWrite(SOLENOID_DOWN, LOW);
  digitalWrite(SOLENOID_LEFT, LOW);
  digitalWrite(SOLENOID_RIGHT, LOW);
  Serial.println("All Solenoids Off");
  return;
}

void terminateAutoExec(){
  changeAutoState(PUSHBLOCK);              // So that we always start at state 0
  turnAllSolenoidsOff();
  return;
  }

void runAuto(){
  if(!automode){
    return;
    }                    //exit if automode is disabled
  
  if(autoState==PUSHBLOCK){
    if(!stateIsSetup){
      digitalWrite(SOLENOID_RIGHT, HIGH);
      drawerBeginTime = millis();
      stateIsSetup = true;
    }
    else if(digitalRead(drawerLeftSens)==HIGH || pressureIsHigh() ){
      drawerEndTime = millis();
      digitalWrite(SOLENOID_RIGHT, LOW);
      drawerMoveTime = drawerEndTime-drawerBeginTime;
      //digitalWrite(SOLENOID_LEFT, HIGH);        //depressurize cylinder by moving back a bit
      //delay(pressureReliefTime);
      //digitalWrite(SOLENOID_LEFT, LOW);
      changeAutoState(LOADSOIL);
    }
  }
  else if(autoState==LOADSOIL){
    if(!stateIsSetup){
      digitalWrite(SOLENOID_DOWN, HIGH);
      mainBeginTime=millis();
      stateIsSetup=true;
      Serial.println("Loading Soil."); 
      Serial.print("Selector Poisition:"); Serial.println(selectorCheck(), DEC);
    }
    else if(selectorCheck()==0){                   //for full block mode, drop until pressure is high
     if(pressureIsHigh()){
      digitalWrite(SOLENOID_DOWN, LOW);
      //digitalWrite(SOLENOID_UP, HIGH);          //1-26-2020 removed pressure relief stage
      //delay(pressureReliefTime);
      //digitalWrite(SOLENOID_UP, LOW);
      changeAutoState(CLOSECHAMBER);
     }
    }
    else if(selectorCheck()==1||2||3||4){            //for partial block mode, drop until time determined in dropTime() function
      if(!dropTimePrinted){
      Serial.print("Drawer Move Time:"); Serial.println(drawerMoveTime, DEC);
      Serial.print("Drop Time Calculated:"); Serial.println(dropTime(), DEC);
      dropTimePrinted=true;
      }
      if(mainBeginTime + dropTime() < millis() || pressureIsHigh()){
        digitalWrite(SOLENOID_DOWN, LOW);
        changeAutoState(CLOSECHAMBER);
        
      }
    }
  }
  else if(autoState==CLOSECHAMBER){
    if(!stateIsSetup){
    dropTimePrinted=false;
    digitalWrite(SOLENOID_LEFT, HIGH);
    previousMillis=millis();
    stateIsSetup=true;
    }
    else if(digitalRead(drawerMidSens)==HIGH){    //using a drawer mid-point sensor and timing as backup
      digitalWrite(SOLENOID_LEFT, LOW);
      Serial.println("Mid Point Sensor Triggered");
      changeAutoState(PRESSBLOCK);
    }
    else if(millis()>previousMillis+(drawerMoveTime*27/64) ){   //1-26-2020 added parenthesis just in case PEMDAS isn't being followed
      digitalWrite(SOLENOID_LEFT, LOW);
      Serial.println("Mid Point Timing Interrupt");
      changeAutoState(PRESSBLOCK);
    }
  }
  else if(autoState==PRESSBLOCK){
    if(!stateIsSetup){
      digitalWrite(SOLENOID_UP, HIGH);
      stateIsSetup=true;
    }
    else if(pressureIsHigh()){
      delay(PRESS_DELAY);                //hold high pressure on block for configured time
      digitalWrite(SOLENOID_UP, LOW);
      Serial.println("Block Pressed. Lowering Block");
      digitalWrite(SOLENOID_DOWN, HIGH);  //back off pressure
      delay(PRESS_DELAY/2);               //
      digitalWrite(SOLENOID_DOWN, LOW);
      Serial.println("Block Lowered.");
      changeAutoState(OPENCHAMBER);
    }
  }
  else if(autoState==OPENCHAMBER){
    if(!stateIsSetup){
      digitalWrite(SOLENOID_LEFT, HIGH);
      stateIsSetup=true;
    }
    else if(digitalRead(drawerRightSens)==HIGH){ //||pressureIsHigh() //1-20-2020 removed or condition
      digitalWrite(SOLENOID_LEFT, LOW);
      //digitalWrite(SOLENOID_RIGHT, HIGH);          //1-21-2020 removed back off pressure steps
      //delay(pressureReliefTime);
      //digitalWrite(SOLENOID_RIGHT, LOW);
      changeAutoState(RAISEBLOCK);
    }
  }
  else if(autoState==RAISEBLOCK){
    if(!stateIsSetup){
      digitalWrite(SOLENOID_UP, HIGH);
      stateIsSetup=true;
    }
    else if (pressureIsHigh()){
     digitalWrite(SOLENOID_UP, LOW);
     changeAutoState(PUSHBLOCK);
   }
 }
}

































void setup() {
//initialize pin I/O Inputs and turn everything off to avoid startup glitches
//always consider internal pullup resistor states when making wiring changes to prevent damage to the microcontroller pins

//Selector Switch
  pinMode(SELECTOR_QUARTER, INPUT_PULLUP);
  pinMode(SELECTOR_HALF, INPUT_PULLUP);
  pinMode(SELECTOR_THREEQUARTER, INPUT_PULLUP);
  pinMode(SELECTOR_FULL, INPUT_PULLUP);

//Solenoids
  pinMode(SOLENOID_RIGHT, OUTPUT);
  digitalWrite(SOLENOID_RIGHT, LOW);
  pinMode(SOLENOID_LEFT, OUTPUT);
  digitalWrite(SOLENOID_LEFT, LOW);
  pinMode(SOLENOID_DOWN, OUTPUT);
  digitalWrite(SOLENOID_DOWN, LOW);
  pinMode(SOLENOID_UP, OUTPUT);
  digitalWrite(SOLENOID_UP, LOW);

//Sensors
  pinMode(PRESSURE_SENSOR, INPUT_PULLUP);
 // digitalWrite(PRESSURE_SENSOR, INPUT_PULLUP);
  pinMode(drawerMidSens, INPUT);
  digitalWrite(drawerMidSens, LOW);
//Buttons
  pinMode(btnU, INPUT_PULLUP);
  pinMode(btnD, INPUT_PULLUP);
  pinMode(btnL, INPUT_PULLUP);
  pinMode(btnR,INPUT_PULLUP);
  pinMode(btnM, INPUT_PULLUP);

//Switches
 pinMode(switchAUTO, INPUT_PULLUP);

//Serial Communications
  Serial.begin(9600);

}




void loop() {
 setAuto();      //call the function to check if machine is in auto or manual mode
 if(automode){   
    runAuto();
    drawerGoMidFlag=false;
    drawerGoRevMid=false;
 } else{
      runButtons(); //if in manual mode or in case of switch failure, buttons are activated.
      drawerGoMid();
 }
 if(pressureIsHigh()){
   if(!pressureIsPrinted){
       Serial.println("High Pressure!");
       pressureIsPrinted=true;
    }
  }
 if(!pressureIsHigh()){
  pressureIsPrinted=false;
 }
 //if(digitalRead(btnM)==LOW){
  //Serial.println("Mid Button Pressed:");
 //}
/* if(digitalRead(drawerRightSens)==HIGH){
  Serial.println("DRAWER RIGHT SENSOR TRIGGERED");
 }
 if(digitalRead(drawerLeftSens)==HIGH){
  Serial.println("DRAWER LEFT SENSOR TRIGGERED");
 }
 */
 //Serial.println(automode, DEC);
}
 
